/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_ITER_COUNT_H_INCLUDED_)
#define _HARKLIB_NODE_ITER_COUNT_H_INCLUDED_ 1

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"

#include "hark-lib/node/IterCount.h"

namespace hark
{
namespace node
{
    class IterCount: public NodeDef
    {
    public:
        IterCount();

        void initialize(InputDataBundle &input);
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        bool sync;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_ITER_COUNT_H_INCLUDED_) */

/* end of file */
